var Chat = {
	run: function (options) {
		this.id = options.id;
		this.checkInterval = options.checkInterval;
		this.maxLength = options.maxLength;
		this.ticket = options.ticket;
		this.activ = true;
		this.count = 0;

		// Скриваем кнопку прокрутки 
		document.getElementById("down").style.display = "none";

		// Скрываем кнопку удаления сообщений
		document.getElementById("dellButton").style.display = "none";
		

		// Запрашиваем разрешение на уведомления в браузере
		if ("Notification" in window) {
			if (Notification.permission !== 'denied') {
				Notification.requestPermission(function (permission) {
					// Если пользователь разрешил, то начинаем отслеживать активность окна
					if (permission === "granted") {
						window.onfocus = function () {
							Chat.activ = true;
							console.log('onfocus');
						}
						window.onblur = function () {
							Chat.activ = false;
							console.log('onblur');

						}
					}
				});
			}
			
		}

		this.soundNew = new Audio();
		this.soundNew.src = '/modules/chat/new.wav';
		this.soundSend = new Audio();
		this.soundSend.src = '/modules/chat/send.wav';





		// if (document.getElementById("msg")) {
		// 	document.getElementById("msg").onfocus = function () {
		// 		Chat.scroll();
		// 	}
		// }

		// Начинаем проверку на наличие новых сообщений
		this.newCheck();
		this.newCheckIntervalId = setInterval(function () {
			console.log('newCheck');
			Chat.newCheck(); 
		}, this.checkInterval);
		

		//this.load(this.scroll);
	},

	// commentDellCheck: function () {
	// 	var checked = document.querySelectorAll("input[type=\"checkbox\"]:checked");
	// 	var commentDellButton = document.getElementById("commentDellButton");
	// 	if (checked.length > 0) {
	// 		commentDellButton.innerHTML = "Удалить выделенное (" + checked.length + ")";
	// 		commentDellButton.style.display = "";
	// 	} else {
	// 		commentDellButton.style.display = "none";
	// 	}
	// },


	// commentDell: function () {
	// 	var commentDellButton = document.getElementById("commentDellButton");
	// 	commentDellButton.innerHTML = "Удаление...";

	// 	var formData = new FormData();
	// 	var checked = document.querySelectorAll("input[type=\"checkbox\"]:checked");
	// 	for (var i = 0; i < checked.length; ++i) {

	// 		formData.append(checked[i].name, checked[i].value);

	// 		var commentDOM = document.getElementById("comment" + checked[i].value);
	// 		commentDOM.parentNode.removeChild(commentDOM);
	// 	} 
	// 	formData.append("ticket", this.ticket);

	// 	JLoader.request(this.id + "/ajax/dellcomments", {
	// 		data: formData,// Данные
	// 		success: function (response) {
	// 			if (response != "Error") {
	// 				commentDellButton.innerHTML = "Готово";
	// 			} else {
	// 				commentDellButton.innerHTML = "Ошибка";
	// 			}
	// 		},
	// 		error: function () {
	// 			commentDellButton.innerHTML = "Ошибка";
	// 		},
	// 	});
	// 	return false;
	// },
	openListOnline: function () {
		var loadlistonline = document.getElementById("loadlistonline");
		var listonline = document.getElementById("listonline");
		JLoader.request(this.id + "/ajax/online", {
			responseToId: "loadlistonline",
			error: function (msg) {
				loadlistonline.innerHTML = msg;
			}
		});


		
		listonline.style.height = "500px";
	},
	closeListOnline: function () {
		var listonline = document.getElementById("listonline");
		listonline.style.height = 0;
	},
	

	dellCheck: function () {
		var checked = document.querySelectorAll("input[type=\"checkbox\"]:checked");
		var dellButton = document.getElementById("dellButton");
		if (checked.length > 0) {
			dellButton.innerHTML = "Удалить выделенное (" + checked.length + ")";
			dellButton.style.display = "";
		} else {
			dellButton.style.display = "none";
		}
	},


	dell: function () {
		var dellButton = document.getElementById("dellButton");
		dellButton.innerHTML = "Удаление...";

		var formData = new FormData();
		var checked = document.querySelectorAll("input[type=\"checkbox\"]:checked");
		for (var i = 0; i < checked.length; ++i) {

			formData.append(checked[i].name, checked[i].value);

			var commentDOM = document.getElementById("id" + checked[i].value);
			commentDOM.parentNode.removeChild(commentDOM);
		}
		formData.append("ticket", this.ticket);

		JLoader.request(this.id + "/ajax/dell", {
			data: formData,// Данные
			success: function (response) {
				if (response != "Error") {
					dellButton.innerHTML = "Готово";
				} else {
					dellButton.innerHTML = "Ошибка";
				}
				setTimeout(function () {
					// Скрываем кнопку удаления сообщений
					document.getElementById("dellButton").style.display = "none";
				}, 3000);
			},
			error: function () {
				dellButton.innerHTML = "Ошибка";
			},
		});
		return false;
	},

	toUser: function (login) {
		var obj = document.getElementById("msg");
		obj.value += "[b]" + login + "[/b], ";
		obj.focus();
		obj.setSelectionRange(obj.value.length, obj.value.length);
	},

	clear: function () {
		if (document.getElementById("msg")) {
			document.getElementById("msg").value = "";
		}
	},

	


	down: function () {
		document.getElementById("down").style.display = "none";
		this.scroll();
	},

	// msgCheck: function () {
	// 	if (document.getElementById("textForm")) {
	// 		var textForm = document.getElementById("textForm");
	// 		var textReport = document.getElementById("textReport");
	// 		textForm.oninput = function () {
	// 			if (textForm.value.length > Comments.commentMaxLength) {
	// 				textReport.innerHTML = "Превышен лимит символов";
	// 			} else {
	// 				textReport.innerHTML = "";
	// 			}
	// 		}
	// 	}

	// },


	// requestReport: function (msg, color, timer) {
	// 	if (document.getElementById("requestReport")) {
	// 		var element = document.getElementById("requestReport");
	// 		element.innerHTML = msg;
	// 		element.style.display = "";
	// 		element.className = color + " animatShow";
	// 		if (timer) {
	// 			setTimeout(function () {
	// 				element.className += " animatHide";
	// 			}, timer);
	// 		}
	// 	}
	// },

	// requestReportHide: function () {
	// 	document.getElementById("requestReport").style.display = "none";
	// },

	submit: function () {
		//this.requestReport("Отправка...", "grey");

		this.scroll();
		

		var formData = new FormData(document.form);
		JLoader.request(this.id + "/ajax/add", {
			data: formData,// Данные
			success: function (response) {
				Chat.clear();

				// Звук отправки сообщения
				Chat.soundSend.volume = 1;
				Chat.soundSend.play();

				Chat.load(Chat.count, Chat.animatedScroll);



				// console.log('response - '+response);
				// console.log('typeof - ' + typeof response);

				function isNumeric(n) {
					return !isNaN(parseFloat(n)) && isFinite(n);
					// http://learn.javascript.ru/number
				}
				if (isNumeric(response)) {
					// 	Сообщение успешно добавлено
					Chat.count = response;
					
					
					
				} else {
					if (response == "Authorized") { alert("Вы не авторизованы"); }
					else if (response == "Strlen") { alert("Слишком длинное или короткое сообщение"); }
					else if (response == "Error") { alert("Ошибка при добавлении сообщения"); }
					else if (response == "Ticket") { alert("Ошибка при проверке безопасности"); }
					else { alert("Неизвестные данные ответа сервера"); }
				}

				
			},
			error: function (msg) {
				alert("Произошла ошибка при запросе к серверу");
			}
		});
		return false;
	},

	

	load: function (count, scrollfunc) {
		JLoader.request(this.id + "/ajax/loadchat/" + count, {
			responseToIdAdd: "posts",
			success: function (response) {
				scrollfunc();
				console.log('load count - ' + count);
			}
		});
	},

	scroll: function () {
		var target = document.body.scrollHeight - document.body.clientHeight;
		document.documentElement.scrollTop = target;
		document.body.scrollTop = target;
		console.log('scroll - ' + target);
	},

	animatedScroll: function () {
		var target = document.body.scrollHeight - document.body.clientHeight;
		var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
		if ((target - scrollTop) < 400){
			var scrollIntervalId = setInterval(function () {
				
				var stp = 5;
			
				if ((document.documentElement.scrollTop + stp) > target || (document.body.scrollTop + stp) > target) {
					document.documentElement.scrollTop = target;
					document.body.scrollTop = target;
					clearInterval(scrollIntervalId);
				}

				document.documentElement.scrollTop += stp;
				document.body.scrollTop += stp;
			
				console.log('animatedScroll - ' + target);
			}, 15);
		} else {
			document.getElementById("down").style.display = "";
		}
		
	},


	notify: function () {
		if (!Chat.activ) {
			console.log('notify');
			// Проверка поддерживаемости браузером уведомлений
			if ("Notification" in window) {
				console.log(Notification.permission);
				if (Notification.permission == "granted" ) {
					
					// Если разрешено то создаем уведомлений
					var notification = new Notification("Чат", {
						tag: "chat",
						body: "В чате написано новое сообщение",
						icon: "/modules/chat/notification.png"
					});
					notification.onclick = function () {
						window.focus();
						this.close();
					};
				}



			}
		}

	},

	newCheck: function () {
		
			console.log('request newCheck');
			JLoader.request(Chat.id + "/ajax/newcheck", {
				success: function (response) {
					console.log("response newCheck: " + response);

					
					if (Chat.count < response) {
						//var newCount = response - сount;

						

						if (Chat.count == 0) {
							Chat.load(Chat.count, Chat.scroll);
						} else {
							Chat.load(Chat.count, Chat.animatedScroll);
							console.log("response newCheck load: " + response);
						}
							

						// Звук нового сообщения 
						Chat.soundNew.volume = 0.8;
						Chat.soundNew.play();


						// Браузерное уведомдение 
						Chat.notify();

					}
					Chat.count = response;
					
					

				}
			});
	}





}